//using System;


namespace Jenyay.Mathematics
{
	/// <summary>
	///    
	/// </summary>
	public struct Polar
	{
		/// <summary>
		/// ,   
		/// </summary>
		private double m_r;

		/// <summary>
		/// 
		/// </summary>
		private double m_phi;

		#region 

		public Polar (double r)
		{
			m_r = r;
			m_phi = 0.0;
		}

		public Polar (double r, double phi)
		{
			m_r = r;
			m_phi = phi;
		}

		public Polar (Complex x)
		{
			m_r = x.Abs;
			m_phi = x.Arg;
		}
		#endregion

		public Complex Complex
		{
			get
			{
				return new Complex(this);
			}

			set
			{
				m_r = value.Abs;
				m_phi = value.Arg;
			}
		}

		public double R
		{
			get { return m_r; }
			set { m_r = value; }
		}

		public double Phi
		{
			get { return m_phi; }
			set { m_phi = value; }
		}

		public override string ToString()
		{
			return "r=" + m_r.ToString() + " phi=" + m_phi.ToString();
		}

		public static implicit operator Complex (Polar p)
		{
			return new Complex(p);
		}

		public static explicit operator Polar (Complex c)
		{
			return new Polar(c);
		}

	}
}
