using System;
using System.Collections.Generic;
using System.Text;

using NUnit.Framework;

using Jenyay.Mathematics;

namespace MathematicsTest
{
	[TestFixture]
	public class PolynomialTest
	{
		Polynomial _polynomial;

		[SetUp]
		public void Init ()
		{
			//	3.76(2) 4.44(4) 5.04(6) 5.56(8) 6(10) 6.36(12) 6.64(14)

			double[] x = new double[7];
			double[] y = new double[7];

			x[0] = 2;
			y[0] = 3.76;

			x[1] = 4;
			y[1] = 4.44;

			x[2] = 6;
			y[2] = 5.04;

			x[3] = 8;
			y[3] = 5.56;

			x[4] = 10;
			y[4] = 6;

			x[5] = 12;
			y[5] = 6.36;

			x[6] = 14;
			y[6] = 6.64;

			_polynomial = new Polynomial (x, y, 2);
		}

		[Test]
		public void Test1 ()
		{
			Assert.Less (Math.Abs (_polynomial.Coefficients[0] - 3), 0.01, 
				_polynomial.Coefficients[0].ToString ());

			Assert.Less (Math.Abs (_polynomial.Coefficients[1] - 0.4), 0.01,
				_polynomial.Coefficients[1].ToString ());

			Assert.Less (Math.Abs (_polynomial.Coefficients[2] + 0.01), 0.01,
				_polynomial.Coefficients[2].ToString ());


			Assert.Less (Math.Abs (_polynomial.GetValue (7) - 5.31), 0.01, 
				_polynomial.GetValue (7).ToString ());
		}
	}
}
